#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All

Type MyUDT
	a As Long
	b As Long
End Type

#Include "MyUDTQueue.inc"

#If %Def(%PB_CC32)
Macro SHOWITEM=Con.Print
Macro NEWWIN=#Page
Macro GETINPUT=Con.Line.Input
#ElseIf %Def(%PB_Win32)
Macro SHOWITEM=Txt.Print
Macro NEWWIN=Txt.Window("Test", 10, 10) To i
Macro GETINPUT=Txt.Line.Input
#EndIf

Function PBMain () As Long
	Local a As String
	Local queue As iMyUDTQueue
	Local i As Long
	Local udt() As MyUDT
	Local tmp As MyUDT

	ReDim udt(2)

	udt(0).a = 0: udt(0).b = 2
	udt(1).a = 1: udt(1).b = 4
	udt(2).a = 2: udt(2).b = 6

	NEWWIN
	Call NewMyUDTQueue( queue, 100, 10 )
	SHOWITEM "Adding udt(0)": queue.Add( udt(0) )
	SHOWITEM "Adding udt(1)": queue.Add( udt(1) )
	SHOWITEM "Adding udt(2)": queue.Add( udt(2) )

	While Not queue.IsEmpty()
		tmp = queue.Remove()
		SHOWITEM "Removing udt("; Format$(tmp.a); ") b value is ";tmp.b
	Wend

	SHOWITEM
	SHOWITEM "Press ENTER to exit"
	GETINPUT a
End Function
