#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All

#Include "StringStack.inc"

#If %Def(%PB_CC32)
Macro SHOWITEM=Con.Print
Macro NEWWIN=#Page
Macro GETINPUT=Con.Line.Input
#ElseIf %Def(%PB_Win32)
Macro SHOWITEM=Txt.Print
Macro NEWWIN=Txt.Window("Test", 10, 10) To i
Macro GETINPUT=Txt.Line.Input
#EndIf

Function PBMain () As Long
	Local a As String
	Local stack As iStringStack
	Local i As Long

	NEWWIN
	Call NewStringStack( stack, 100, 10 )
	SHOWITEM "Push First":   stack.Push("First")
	SHOWITEM "Push Second":  stack.Push("Second")
	SHOWITEM "Push Third":   stack.Push("Third")

	While Not stack.IsEmpty()
		SHOWITEM "Pop "; stack.Pop()
	Wend

	SHOWITEM
	SHOWITEM "Press ENTER to exit"
	GETINPUT a
End Function
