
AsmData PrimeCollectionSizes
	DD 17, 37, 67, 131, 257, 521, 1031, 2053
	DD 4099, 8209, 16411, 32771, 65537
	DD 131101, 262147, 524309, 1048583
	DD 2097169, 4194319, 8388617, 16777259
	DD 33554467, 67108879, 134217757
	DD 268435459, 536870923, 1073741827
End AsmData

Function CollectionSize( ByVal capacity As Long ) As Long
	Register i As Long
	Register l As Long
	Local h As Long
	Local primes As Long Ptr

	primes = CodePtr( PrimeCollectionSizes )

	'l = 0: ' l already 0
	h = 26  ' 27 prime values in table (0-26)
	While l+1<h
		i = (l+h)
		Shift Right i, 1
		If @primes[i] = capacity Then
			Function = @primes[i]
			Exit Function
		ElseIf @primes[i] < capacity Then
			l = i
		Else
			h = i
		End If
	Wend

	If @primes[l]>=capacity Then
		Function = @primes[l]
	Else
		Function = @primes[h]
	End If
End Function
