#Compile Exe
#Compiler PBWin 10, PBCC 6
#Dim All

#Include "LongToLongMap.inc"

#If %Def(%PB_CC32)
Macro SHOWITEM=Con.Print
Macro NEWWIN=#Page
Macro GETINPUT=Con.Line.Input
#ElseIf %Def(%PB_Win32)
Macro SHOWITEM=Txt.Print
Macro NEWWIN=Txt.Window("Test", 10, 10) To i
Macro GETINPUT=Txt.Line.Input
#EndIf

Function PBMain () As Long
	Local a As String
	Local map As iLongToLongMap
	Local i As Long

	NEWWIN

	Call NewLongToLongMap( map, 100, 10 )
	map.Add(1, 4)
	map.Add(2, 7)

	If Not map.Contains(1) Then SHOWITEM "No one"
	If Not map.Contains(2) Then SHOWITEM "No two"
	If map.Contains(3) Then SHOWITEM "Has three?"
	If map.Item(1)<>4 Then SHOWITEM "1 doesn't map to 4"
	If map.Item(2)<>7 Then SHOWITEM "2 doesn't map to 7"

	For i=0 To map.Count-1
		SHOWITEM map.Key(i); " maps to ";map.Value(i)
	Next

	SHOWITEM
	SHOWITEM "Press ENTER to exit"
	GETINPUT a
End Function
