#Compile  Exe
#Compiler PBWin 10, PBCC 6
#Dim All

#Include "StringToiStringBagMap.inc"
#Include "StringBag.inc"

#If %Def(%PB_CC32)
Macro SHOWITEM=Con.Print
Macro NEWWIN=#Page
Macro GETINPUT=Con.Line.Input
#ElseIf %Def(%PB_Win32)
Macro SHOWITEM=Txt.Print
Macro NEWWIN=Txt.Window("Test", 10, 10) To i
Macro GETINPUT=Txt.Line.Input
#EndIf

Function PBMain () As Long
	Local a As String
	Local map As iStringToiStringBagMap
	Local bag As iStringBag
	Local j, i, c As Long

	NEWWIN
	Call NewStringToiStringBagMap( map, 100, 10 )

	Call NewStringBag( bag, 10, 10 )
	bag.Add("One")
	bag.Add("Two")
	bag.Add("Three")
	map.Add("Numbers", bag)

	Call NewStringBag( bag, 10, 10 )
	bag.Add("Basic")
	bag.Add("C")
	bag.Add("C++")
	bag.Add("D")
	map.Add("Compilers", bag)

	If Not map.Contains("numbers") Then SHOWITEM "No numbers"
	If Not map.Contains("compilers") Then SHOWITEM "No compilers"
	If map.Contains("interpreters") Then SHOWITEM "Has interpreters?"

	bag = map.Item("COMPILERS")
	If IsNothing( bag ) Then SHOWITEM "Couldn't get COMPILERS"

	For j = 0 To map.Count-1
		bag = map.Value(j)
		SHOWITEM
		SHOWITEM map.Key(j)
		If IsObject( bag ) Then
			For i = 0 To bag.Count-1
				SHOWITEM "  "; bag.Key(i)
			Next
		End If
	Next
	SHOWITEM
	SHOWITEM "Press ENTER to exit"
	GETINPUT a
End Function
